
;--- define macros for debugging output
;--- DebugOutNoLF: printf format OutputDebugStringA
;--- DebugOut: printf format OutputDebugStringA

DebugOutNoLF Macro x:req,y:VARARG
local sym,ii
ifdef _DEBUG
	.const
sym label byte
ifdef DBGPRF
	db @CatStr(!",%DBGPRF,!")
endif
	db x,0
	.code
	pushad
  ifnb <y>
	sub esp,256
	ii = 0
	for parname,<y>
	  ii = ii + 4
	endm
	push esp
	invoke wsprintf,[esp+ii+4],addr sym,y
	pop esp
	invoke OutputDebugString,esp
	add esp,256
  else
	invoke OutputDebugString,addr sym
  endif
	popad
endif
	endm

DebugOut macro x:req,y:VARARG
ifnb <y>
	DebugOutNoLF <x,0dh,0ah>,y
else
	DebugOutNoLF <x,0dh,0ah>
endif
	endm

